##########################################################################################
#
# Magisk模块自定义安装脚本
#
##########################################################################################

##########################################################################################
# 替换列表
##########################################################################################

# 列出要在系统中直接替换的所有目录
# 您可以在变量名中声明要直接替换的文件夹列表REPLACE。模块安装程序脚本将提取此变量并为您创建文件.replace。

# 按以下格式构建替换列表
# 示例
REPLACE_EXAMPLE="
/system/app/YouTube
/system/app/Bloatware
"
#上面的替换列表将导致创建以下文件：
#$MODPATH/system/app/YouTube/.replace
#$MODPATH/system/app/Bloatware/.replace

# 在这里构建自定义替换列表
REPLACE="
"

##########################################################################################
# 显示内容
##########################################################################################
echoprint='━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━'
Detect_Gboard() {
for APPF in com.google.android.inputmethod.latin com.baidu.input_mi com.iflytek.inputmethod.miui com.sohu.inputmethod.sogou.xiaomi;do
  [ -f "/data/data/${APPF}/shared_prefs/flag_value.xml" ] && echo "${APPF}" | sed 's/com.google.android.inputmethod.latin/Gboard/g;s/com.baidu.input_mi/Gboard\(百度输入法小米版\)/g;s/com.iflytek.inputmethod.miui/Gboard\(讯飞输入法小米版\)/g;s/com.sohu.inputmethod.sogou.xiaomi/Gboard\(搜狗输入法小米版\)/g'
done
}

read_settings() {
  [ -f "$MODPATH/settings.prop" ] && cat $MODPATH/settings.prop | awk '!/#/ {print $0}' | sed -n "s/^${1}=//p"
}

gboard() {
  for APP in com.google.android.inputmethod.latin com.baidu.input_mi com.iflytek.inputmethod.miui com.sohu.inputmethod.sogou.xiaomi;do
  value=/data/data/${APP}/shared_prefs
  [ -f "${value}/flag_value.xml" ] && {
  preferences=/data/data/${APP}/shared_prefs/${APP}_preferences.xml
  GboardvalueBak=/data/media/0/GboardvalueBak
  valueSE=`ls -Zd $value | awk 'NR==1{print $1}'`
  appname=`echo ${APP} | sed 's/com.google.android.inputmethod.latin/Gboard/g;s/com.baidu.input_mi/Gboard\(百度输入法小米版\)/g;s/com.iflytek.inputmethod.miui/Gboard\(讯飞输入法小米版\)/g;s/com.sohu.inputmethod.sogou.xiaomi/Gboard\(搜狗输入法小米版\)/g'`
  userId=`dumpsys package ${APP} | grep userId= | awk 'NR==1' | cut -d "=" -f 2`
  Package=`dumpsys package ${APP} | grep Package | awk 'NR==1{print $1}' | cut -d "=" -f 2`
  versionName=`dumpsys package ${APP} | grep versionName | awk 'NR==1{print $1}' | cut -d "=" -f 2`
  primaryCpuAbi=`dumpsys package ${APP} | grep primaryCpuAbi | awk 'NR==1{print $1}' | cut -d "=" -f 2`
  versionCode=`dumpsys package ${APP} | grep versionCode | awk 'NR==1{print $1}' | cut -d "=" -f 2`
  minSdk=`dumpsys package ${APP} | grep minSdk | awk 'NR==1{print $2}' | cut -d "=" -f 2`
  targetSdk=`dumpsys package ${APP} | grep targetSdk | awk 'NR==1{print $3}' | cut -d "=" -f 2`
  firstInstallTime=`dumpsys package ${APP} | grep firstInstallTime | awk 'NR==1{print $1}' | cut -d "=" -f 2`
  lastUpdateTime=`dumpsys package ${APP} | grep lastUpdateTime | awk 'NR==1{print $1}' | cut -d "=" -f 2`
  installerPackageName=`dumpsys package ${APP} | grep installerPackageName | awk 'NR==1{print $1}' | cut -d "=" -f 2`
  ProportionalSetSize=`dumpsys meminfo | grep ${APP} | sort -n | uniq -f 1 | cut -d 'K' -f 1 | sed 's/ //g;s/,//g' | awk '{sum += $1};END {print sum/1000}' | awk '{printf("%.f\n",$1)}'`
  
  [ ! -e "$GboardvalueBak" ] && mkdir $GboardvalueBak
  [ ! -f "$GboardvalueBak/flag_value.xml" ] && cp -af $value/flag_value.xml $GboardvalueBak
  
  enable_module_file=`read_settings 模块配置文件`
  count=`wc -l $value/flag_value.xml | awk '{print $1}'`
  if [[ "$enable_module_file" == "true" && -f "$MODPATH/flag_value.xml" ]];then
  ui_print "$echoprint"
  ui_print "– 在模块settings文件中已开启使用模块配置文件,将从模块内置文件进行替换❗ "
  cp -af $MODPATH/flag_value.xml $value/flag_value.xml
  [ "$valueSE" != "" ] && set_perm  $value/flag_value.xml $userId $userId 0660 $valueSE || set_perm  $value/flag_value.xml $userId $userId 0660 u:object_r:app_data_file:s0
  elif [[ "$count" -le "10" && -f "$MODPATH/flag_value.xml" ]];then
  ui_print "$echoprint"
  ui_print "– ⚠️软件配置文件出现问题,更改可能无法生效,将从模块内置文件进行替换⁉️ "
  cp -af $MODPATH/flag_value.xml $value/flag_value.xml
  [ "$valueSE" != "" ] && set_perm  $value/flag_value.xml $userId $userId 0660 $valueSE || set_perm  $value/flag_value.xml $userId $userId 0660 u:object_r:app_data_file:s0
  elif [[ "$count" -le "10" ]];then
  ui_print "$echoprint"
  ui_print "– ⚠️软件配置文件出现问题,更改可能无法生效,尝试清除应用数据后刷入⁉️ "
  fi
  
  package_whitelist=`read_settings 应用白名单`
  locales_language_tags=`read_settings 语言标签`
  themed_nav_bar_style=`read_settings 主题导航栏样式`
  show_branding_on_space=`read_settings 在空格键显示LOGO`
  branding_fadeout_delay_ms=`read_settings LOGO淡入延迟时间`
  show_branding_interval_seconds=`read_settings LOGO显示间隔时间`
  height=`read_settings 键盘高度`
  heightjc=`cat $preferences | grep keyboard_height_ratio | cut -d ">" -f 2 | cut -d "<" -f 1`
  corner=`read_settings 键盘左右下圆角`
  vbinch=`read_settings 键盘竖屏底部间距`
  hbinch=`read_settings 键盘横屏底部间距`
  vlinch=`read_settings 键盘竖屏左部间距`
  hlinch=`read_settings 键盘横屏左部间距`
  vrinch=`read_settings 键盘竖屏右部间距`
  hrinch=`read_settings 键盘横屏右部间距`
  cornerprop=`echo | awk "{print $corner*100}"`
  vbinchprop=`echo | awk "{print $vbinch*160}"`
  hbinchprop=`echo | awk "{print $hbinch*160}"`
  vlinchprop=`echo | awk "{print $vlinch*160}"`
  hlinchprop=`echo | awk "{print $hlinch*160}"`
  vrinchprop=`echo | awk "{print $vrinch*160}"`
  hrinchprop=`echo | awk "{print $hrinch*160}"`
  
  value_true=`cat $MODPATH/value_true.prop | awk '!/#/ {print $NF}' | sed '/^$/d'`
  value_false=`cat $MODPATH/value_false.prop | awk '!/#/ {print $NF}' | sed '/^$/d'`
  value_whitelist=`cat $MODPATH/value_whitelist.prop | awk '!/#/ {print $NF}' | sed '/^$/d'`
  value_language=`cat $MODPATH/value_language.prop | awk '!/#/ {print $NF}' | sed '/^$/d'`
  
  #启用
  for value_enable in $value_true ;do
  sed -i 's/name="'$value_enable'" value="false" \/\>/name="'$value_enable'" value="true" \/\>/g' $value/flag_value.xml
  done
  
  #禁用
  for value_disable in $value_false ;do
  sed -i 's/name="'$value_disable'" value="true" \/\>/name="'$value_disable'" value="false" \/\>/g' $value/flag_value.xml
  done
  
  #白名单
  for value_app_whitelist in $value_whitelist ;do
  sed -i 's/name="'$value_app_whitelist'"\>.*\<\/string\>/name="'$value_app_whitelist'"\>'$package_whitelist'\<\/string\>/g' $value/flag_value.xml
  done
  
  #语言标签
  for language_tags in $value_language ;do
  sed -i 's/name="'$language_tags'"\>.*\<\/string\>/name="'$language_tags'"\>'$locales_language_tags'\<\/string\>/g' $value/flag_value.xml
  done
  
  nav_bar_style=`cat $value/flag_value.xml | grep 'themed_nav_bar_style' | awk 'NR==1{print $2}'`
  if [ "$nav_bar_style" != "" ];then
  sed -i 's/name="themed_nav_bar_style" value=".*" \/\>/name="themed_nav_bar_style" value="'$themed_nav_bar_style'" \/\>/g' $value/flag_value.xml
  else
  sed -i '/\<\/map\>/i\    \<long name="themed_nav_bar_style" value="'$themed_nav_bar_style'" \/\>' $value/flag_value.xml
  fi
  
  sed -i 's/name="show_branding_interval_seconds" value=".*" \/\>/name="show_branding_interval_seconds" value="'$show_branding_interval_seconds'" \/\>/g' $value/flag_value.xml
  sed -i 's/name="branding_fadeout_delay_ms" value=".*" \/\>/name="branding_fadeout_delay_ms" value="'$branding_fadeout_delay_ms'" \/\>/g' $value/flag_value.xml
  sed -i 's/name="show_branding_on_space" value=".*" \/\>/name="show_branding_on_space" value="'$show_branding_on_space'" \/\>/g' $value/flag_value.xml
  sed -i 's/name="keyboard_height_ratio"\>.*\<\/string\>/name="keyboard_height_ratio"\>'$height'\<\/string\>/g' $preferences
  sed -i 's/ro.com.google.ime.corner_key_r=.*/ro.com.google.ime.corner_key_r='$cornerprop'/g' $MODPATH/system.prop
  sed -i 's/name="normal_keyboard_bottom_inch" value=".*" \/\>/name="normal_keyboard_bottom_inch" value="'$vbinch'" \/\>/g' $value/flag_value.xml
  sed -i 's/name="normal_keyboard_bottom_gap_from_screen_inch" value=".*" \/\>/name="normal_keyboard_bottom_gap_from_screen_inch" value="'$vbinch'" \/\>/g' $value/flag_value.xml
  sed -i 's/ro.com.google.ime.kb_pad_port_b=.*/ro.com.google.ime.kb_pad_port_b='$vbinchprop'/g' $MODPATH/system.prop
  sed -i 's/ro.com.google.ime.kb_pad_land_b=.*/ro.com.google.ime.kb_pad_land_b='$hbinchprop'/g' $MODPATH/system.prop
  sed -i 's/ro.com.google.ime.kb_pad_port_l=.*/ro.com.google.ime.kb_pad_port_l='$vlinchprop'/g' $MODPATH/system.prop
  sed -i 's/ro.com.google.ime.kb_pad_land_l=.*/ro.com.google.ime.kb_pad_land_l='$hlinchprop'/g' $MODPATH/system.prop
  sed -i 's/ro.com.google.ime.kb_pad_port_r=.*/ro.com.google.ime.kb_pad_port_r='$vrinchprop'/g' $MODPATH/system.prop
  sed -i 's/ro.com.google.ime.kb_pad_land_r=.*/ro.com.google.ime.kb_pad_land_r='$hrinchprop'/g' $MODPATH/system.prop
  ui_print "$echoprint"
  ui_print "– ⌨应用信息->> "
  ui_print "– 应用名称：$appname "
  ui_print "– 应用包名：$Package 应用UID: $userId"
  ui_print "– 应用版本：$versionName "
  ui_print "– 应用架构：$primaryCpuAbi 最小SDK：$minSdk 目标SDK：$targetSdk "
  ui_print "– 安装时间：$firstInstallTime 更新时间：$lastUpdateTime "
  ui_print "– 安装来源：$installerPackageName "
  [ "$ProportionalSetSize" != "" ] && ui_print "– 运存占用：$ProportionalSetSize MB"
  ui_print "$echoprint"
  ls -nh $value/flag_value.xml | awk '{print "- 📄配置文件->> \n- 所有者："$3"  用户组："$4" \n- 文件权限："$1"  文件大小："$5" \n- 文件路径："$NF""}'
  ui_print "$echoprint"
  ui_print "– 📝修改配置->> "
  [ "$heightjc" != "" ] && ui_print "– ↕️键盘高度：$height" || { sed -i 's/ro.com.google.ime.height_ratio=.*/ro.com.google.ime.height_ratio='$height'/g' $MODPATH/system.prop && ui_print "– ↕️键盘高度：${height} (build.prop方式)" ;}
  ui_print "– 🔄键盘圆角：$corner "
  ui_print "– ⬇️键盘底部间距：竖屏 $vbinch | 横屏 $hbinch"
  ui_print "– ⬅️键盘左部间距：竖屏 $vlinch | 横屏 $hlinch"
  ui_print "– ➡️键盘右部间距：竖屏 $vrinch | 横屏 $hrinch"
  ui_print "$echoprint"
  ui_print "– 📌工具栏搜索🇬按钮，空格键Google图标长时间显示，横屏、多窗口自动浮动键盘，中文语音输入，剪贴板自动粘贴建议，导航栏样式跟随主题颜色，包含一系列实验性等设置…… "
  ui_print "– ⚙️如想自定义键盘高度、圆角、间距、键盘布局等参数请使用MT管理器打开模块压缩包文件,修改数值保存后重新刷入模块！(如安装了同类型调整的模块可能会冲突!应用更新可能会恢复初始默认值,请重刷❗) "
  ui_print "$echoprint"
  [ "$valueSE" != "" ] && set_perm  $value/flag_value.xml $userId $userId 0660 $valueSE || set_perm  $value/flag_value.xml $userId $userId 0660 u:object_r:app_data_file:s0
  killall -9 ${APP}
  am force-stop ${APP}
  break;}
  done
}

if [[ `Detect_Gboard | wc -l` -ge "2" ]];then
  ui_print "$echoprint"
  ui_print "– 已安装："
  Detect_Gboard
  ui_print "$echoprint"
  ui_print "– 模块将按顺序配置,只对第一个『$(Detect_Gboard | awk 'NR==1')』生效❗"
  ui_print "– 如需让第二个应用生效，请卸载第一个应用后重新刷入❗ "
  sleep 2
  gboard
  elif [[ `Detect_Gboard | wc -l` -ge "1" ]];then
  gboard
  else
  abort "❗ 未检测到Gboard配置文件,安装失败!"
fi


##########################################################################################
#
# 安装框架将导出一些变量和函数。
# 您应该使用这些变量和函数进行安装。
# 
# !不要使用任何Magisk内部路径，因为它们不是公共API。
# !请勿在util_functions.sh中使用其他函数，因为它们不是公共API。
# !不保证非公共API可以保持版本之间的兼容性。
##########################################################################################
# 可用变量
##########################################################################################
#
# MAGISK_VER (string): 当前安装的Magisk的版本字符串（例如v20.0）
# MAGISK_VER_CODE (int): 当前安装的Magisk的版本代码（例如20000）
# BOOTMODE (bool): 如果模块当前正在Magisk Manager中安装,则为true
# MODPATH (path): 应安装模块文件的路径
# TMPDIR (path): 临时存储文件的地方
# ZIPFILE (path): 安装模块zip文件
# ARCH (string): 设备的CPU架构.值为arm,arm64,x86或x64
# IS64BIT (bool): 如果$ ARCH是arm64或x64,则为true
# API (int): 设备的API级别(Android版本)（例如，21对于Android 5.0）
#
##########################################################################################
# 可用功能
##########################################################################################
#
# ui_print <msg>
#     打印 <msg> 到安装界面
#     避免使用 'echo' 因为它不会显示在自定义安装界面
#
# abort <msg>
#     打印错误消息 <msg> 到安装界面和终止安装
#     避免使用 'exit' 因为它会跳过终止清理步骤
#
# set_perm <目标> <所有者> <组> <权限> [环境]
#     如果未设置[环境]，则默认值为 "u:object_r:system_file:s0"
#     该函数是以下命令的简写：
#       chown 所有者.组 目标
#       chmod 权限 目标
#       chcon 环境 目标
#
# set_perm_recursive <目录> <所有者> <组> <权限> <文件权限> [环境]
#     如果未设置[context]，则默认值为"u:object_r:system_file:s0"
#     对于<目录>中的所有文件，它将调用：
#       set_perm file 所有者 组 文件权限 环境
#     对于<目录>中的所有目录（包括自身），它将调用：
#       set_perm dir 所有者 组 权限 环境
#
##########################################################################################


##########################################################################################
# 权限设置
##########################################################################################


# 只有一些特殊文件需要特定权限
# 安装完成后，此功能将被调用
# 对于大多数情况，默认权限应该已经足够

  # 默认规则
  # set_perm_recursive $MODPATH 0 0 0755 0644
  # 以下是一些例子:
  # set_perm_recursive  $MODPATH/system/lib       0     0       0755      0644
  # set_perm  $MODPATH/system/bin/app_process32   0     2000    0755      u:object_r:zygote_exec:s0
  # set_perm  $MODPATH/system/bin/dex2oat         0     2000    0755      u:object_r:dex2oat_exec:s0
  # set_perm  $MODPATH/system/lib/libart.so       0     0       0644

# 您可以添加更多功能来协助您的自定义脚本代码


